﻿using System;

namespace LambdasEtc
{
    class Program
    {
        static void Main(string[] args)
        {
            CsVersions.TryIt();
            ExecuteCSharp3_0();
            SimpleDelegate();
        }
        public delegate int IncreaseByANumber(int j);

        public delegate int MultipleIncreaseByANumber(int j, int k, int l);

        /// <summary>
        /// http://msdn.microsoft.com/en-us/library/orm-9780596516109-03-09.aspx
        /// </summary>
        public static void ExecuteCSharp3_0()
        {
            // declare the lambda expression
            IncreaseByANumber increase = j => j * 42;
            
            int aNumber = 10;
            // invoke the method and print 420 to the console
            Console.WriteLine(increase(aNumber));
            Console.WriteLine(aNumber);

            MultipleIncreaseByANumber multiple = (j, k, l) => ((j * 42) / k) % l;
            Console.WriteLine(multiple(10, 11, 12));
        }

         delegate int CalculationDelegate(int a, int b);

        /// <summary>
         /// http://en.wikipedia.org/wiki/Callback_%28computer_science%29#JavaScript
        /// </summary>
        public static void SimpleDelegate()
        {
            SomeMethodUsingCallback(4,5, Sum);
            SomeMethodUsingCallback(2,3, Product);
        }

        static void SomeMethodUsingCallback(int a, int b, CalculationDelegate calc)
        {
            Console.WriteLine(calc(a, b));
        }

        static int Sum(int a, int b)
        {
            return a + b; 
        }

        static int Product(int a, int b)
        {
            return a*b;
        }
    }
}
